window.News = function (newsType, title)
{
	this.newsType = newsType;
	this.title = title;
	this.newsCacheBase = this.cacheDataBase = new BX.dataBase({
		name: "NewsCache",
		displayName: "NewsCache",
		capacity: 1024 * 1024 * 4,
		version: "1.2"
	});

	this.tableParams =
	{
		tableName: "newslist",
		fields: [
			"id",
			"content",
			"title"
		]
	};
	this.newsCacheBase.createTable(this.tableParams);
};

News.prototype.load = function ()
{
	BX.ajax.get("/demonews/new_json.php?newsType=" + this.newsType, {}, BX.proxy(function (data)
	{
		BXMobileApp.UI.Page.PopupLoader.hide();
		BXMPage.getTitle().setText(this.title);
		BXMPage.getTitle().show();


		var newsList = JSON.parse(data);

		BX.proxy(function ()
		{
			this.updateCache(data, this.title);

		}, this)();


		this.drawNewList(newsList);

	}, this));
};
News.prototype.openDetail = function(e)
{

	var params = {
		cache: false,
		url: e.target.getAttribute("data-url")
	};
	console.log( e.target);
	BXMobileApp.PageManager.loadPageBlank(params);
};
News.prototype.drawNewList = function (newsList)
{
	var container = BX("news");
	container.innerHTML = "";
	BX.bindDelegate(container,"click",{className:"news-block"}, BX.proxy(this.openDetail,this));
	for (var key in newsList)
	{
		var newsBlock = BX.create("DIV", {

			props: {
				className: "news-block noselect"
			},
			attrs:{
				"data-url":newsList[key].link
			},
			children: [
				BX.create("DIV", {
					html: newsList[key].title,
					attrs:{
						"data-url":newsList[key].link
					},
					props: {
						className: "news-title"
					}
				}),
				BX.create("DIV", {
					html: newsList[key].description,
					attrs:{
						"data-url":newsList[key].link
					},
					props: {
						className: "news-desc"
					}
				})
			]

		});




		container.appendChild(newsBlock);
	}
};
News.prototype.loadFromCache = function (callback)
{
	this.newsCacheBase.getRows(
		{
			tableName: this.tableParams.tableName,
			filter: {id: this.newsType},
			success: BX.proxy(function (resultSet)
			{
				if (resultSet.items.length > 0)
				{
					var newsList = JSON.parse(resultSet.items[0].CONTENT);
					this.drawNewList(newsList);
				}
				console.log("cache read success");
				callback();

			},this),
			fail: function (res)
			{
				console.log("cache read fail");
				console.log(res);
				callback();

			}
		}
	)
};
News.prototype.updateCache = function (content, title)
{
	this.newsCacheBase.getRows(
		{
			tableName: this.tableParams.tableName,
			filter: {id: this.newsType},
			success: BX.proxy(function (res)
			{
				if (res.items.length > 0)
				{
					this.newsCacheBase.updateRows(
						{
							tableName: this.tableParams.tableName,
							updateFields: {
								content: content,
								title: title
							},
							filter: {
								id: this.newsType
							},
							fail: function (e)
							{
								//console.error("Update cache error: ", e);
							}

						}
					)
				}
				else
				{
					this.cacheDataBase.addRow(
						{
							tableName: this.tableParams.tableName,
							insertFields: {
								id: this.newsType,
								content: content
							}
						}
					);
				}
			}, this)
		}
	)
};


var Menu = function (menucontainer)
{
	this.menuBlock = menucontainer;

};
Menu.prototype.init = function ()
{
	BitrixMobile.fastClick.bindDelegate(this.menuBlock, {className: "item-menu"}, BX.proxy(this.click, this));

};
Menu.prototype.click = function (e)
{

	var id = e.target.getAttribute("data-news-id");
	var title = e.target.getAttribute("data-news-title");

	var params = {
		title: BX.type.isNotEmptyString(title) ? title : "Новости",
		cache: false,
		url: "bxlocal://index.html",
		data: {
			id: id
		}
	};

	BXMobileApp.PageManager.loadPageStart(params);

};




